#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include <vector> 
#include <algorithm>
#include"SimpleImage.h"
#include"BMPIO.h"
#include"SimpleImage3D.h"
#include"VideoIO.h"


#define PI 3.141592653589793238462643383279502884197
#define ABS(x) ((x) >= 0 ? (x) : -(x))



/* 正規化用の関数 */
void Normalize(Image3D *R,Image3D *G,Image3D *B){
  double max,min;
  max= min = R->img[0][0][0];
  int i,j,k;
  for(k=0;k<R->st;k++)
  for(i=0;i<R->sy;i++)
    for(j=0;j<R->sx;j++){
      if(max<R->img[k][i][j])max=R->img[k][i][j];
      if(max<G->img[k][i][j])max=G->img[k][i][j];
      if(max<B->img[k][i][j])max=B->img[k][i][j];
      if(min>R->img[k][i][j])min=R->img[k][i][j];
      if(min>G->img[k][i][j])min=G->img[k][i][j];
      if(min>B->img[k][i][j])min=B->img[k][i][j];
    }
  double range = fabs(max-min);if(range<=0.0)range=1.0;
   for(k=0;k<R->st;k++)
  for(i=0;i<R->sy;i++)
     for(j=0;j<R->sx;j++){
       double val = 255.0*(R->img[k][i][j]-min)/range;if(val<0.0)val=0.0;if(val>255.0)val=255.0;
      R->img[k][i][j] = val;
      val = 255.0*(G->img[k][i][j]-min)/range;if(val<0.0)val=0.0;if(val>255.0)val=255.0;
      G->img[k][i][j] = val;
      val = 255.0*(B->img[k][i][j]-min)/range;if(val<0.0)val=0.0;if(val>255.0)val=255.0;
      B->img[k][i][j] = val;
     }
     
}


/* 量子化 */
void Quantization(Image3D *in,Image3D *out,int binN){
  int i,j,k;
  double max=in->img[0][0][0];
  for(k=0;k<in->st;k++)
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++){
	if(max<in->img[k][i][j])max=in->img[k][i][j];
      }
  if(max<=0.0)max=1.0;
  for(k=0;k<in->st;k++)
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++){
	double val = ((double)(binN))*in->img[k][i][j]/max;
	int vali = ((int)(val));
	if(fabs(((double)(vali))-val)>=0.5)vali++;
	out->img[k][i][j] = ((double)(vali))*max/((double)(binN));
      }
  }
/* 量子化 */
void Quantization(Image3D *in,Image3D *out,int radii_t,int binN){
  int i,j,k,t;
  
  
  for(t=0;t<in->st;t++){
    
    double max=in->img[t][0][0];
    
    for(k=t-radii_t;k<=t+radii_t;k++){
      if(k>=0&&k<in->st)
	for(i=0;i<in->sy;i++)
	  for(j=0;j<in->sx;j++){
	    if(max<in->img[k][i][j])max=in->img[k][i][j];
	  }
    }
    if(max<=0.0)max=1.0;
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++){
	double val = ((double)(binN))*in->img[t][i][j]/max;
	int vali = ((int)(val));
	if(fabs(((double)(vali))-val)>=0.5)vali++;
	out->img[t][i][j] = ((double)(vali))*max/((double)(binN));
      }
  }
}
/* maxで割る正規化 */
void Normalize(Image3D *in){
  int i,j,k;
  double min,max;
  min=max=in->img[0][0][0];
  for(k=0;k<in->st;k++)
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++){
	if(min>in->img[k][i][j])min=in->img[k][i][j];
	if(max<in->img[k][i][j])max=in->img[k][i][j];
      }
  max=fabs(max);
  if(max<=0.0)max=1.0;
  for(k=0;k<in->st;k++)
    for(i=0;i<in->sy;i++)
      for(j=0;j<in->sx;j++)in->img[k][i][j]/=max;
  
}


/* HSV量子化: Hue色相だけbinNの数に量子化、alphaは明度Vの強調パラメータ */
 void QuantizationHSV(Image3D *R,Image3D *G,Image3D *B,int binN,int radii_t,double alpha){
   int i,j,k;
   
  Normalize(R,G,B);
  
  int localst = 2*radii_t+1;
  //RGB->HSV
  for(k=0;k<R->st;k++){
    Image3D *H = new Image3D(R->sx,R->sy,localst);
    Image3D *S = new Image3D(R->sx,R->sy,localst);
    Image3D *V = new Image3D(R->sx,R->sy,localst);
    for(int l=-radii_t;l<=radii_t;l++){
      int l2 = l+radii_t;
      int w = l+k;if(w<0)w=0;if(w>=R->st)w=R->st-1;
      
      /* ここを作成: ImageQuantization.cxxを参照し3D化、ただし、時間方向はl2を使う　*/


    }
    Normalize(S);
    Normalize(V);
    for(int l=-radii_t;l<=radii_t;l++){
      int l2 = l+radii_t;
       /* ここを作成: ImageQuantization.cxxを参照し3D化、ただし、時間方向はl2を使う　*/

    }
    Quantization(H,H,binN);
    
    
      //HSV->RGB
    /* ここを作成: ImageQuantization.cxxを参照し3D化、ただし、、時間方向はR、G、Bはkを使い、H,S,Vはradii_tを使う．
       例： H->img[radii_t][i][j], R->img[k][i][j]
     */

    
     delete H;
     delete S;
     delete V; 
  }
  

}



/* g++ -o VideoQuantization VideoQuantization.cxx -lm
引数6個
./VideoQuantization 入力ファイル名 出力ファイル名 量子化時間方向半径(int) HSV量子化数(int) HSV量子化V強調パラメータ(double) RGB量子化数(int) 
*/

int main(int argc,char *argv[]){
  int sx,sy,st;
  Image3D *R = NULL;
  Image3D *G = NULL;
  Image3D *B = NULL;
  OpenVideo(argv[1],&R,&G,&B,&sx,&sy,&st);
  
  int i,j,k;
  
  Image3D *outR = new Image3D(sx,sy,st);
  Image3D *outG = new Image3D(sx,sy,st);
  Image3D *outB = new Image3D(sx,sy,st);
  
  /* 量子化時間方向半径 */
  int radii_t = atoi(argv[4]);
   /* HSVのHを多値化する数 */
  int HSV_N = atoi(argv[5]);
  /* HSV量子化のV強調パラメータ */
  double alpha = atof(argv[6]);
  /* RGBを多値化する数 */
  int RGB_N = atoi(argv[7]);

  
  /* HSV量子化:色相Hの多値化+明度Vの強調 */
  QuantizationHSV(R,G,B,HSV_N,radii_t,alpha);
  /* R,G,B別の多値化　*/
  Quantization(R,outR,radii_t,RGB_N);
  Quantization(G,outG,radii_t,RGB_N);
  Quantization(B,outB,radii_t,RGB_N);
  
  
  
    /* 出力量子化画像の保存 */
   printf("save video\n");
   SaveVideo(argv[2],argv[3],outR,outG,outB);
   
  
  
   /* メモリの開放 */
  printf("delete data \n");
    
  delete R;
  delete G;
  delete B;


  delete outR;
  delete outG;
  delete outB;

 
  return 0;
}

#undef PI
#undef ABS
